  ; Writer : Onan Farabi
  ; OpenCV experiment
  
   include highgui.inc
   include cv.inc
   include cxcore.inc
   include cvcam.inc
   include cvhaartraining.inc
   include cxts.inc
   include cvaux.inc
   include ml.inc

includelib cv.lib
includelib highgui.lib
includelib cxcore.lib
    includelib cvcam.lib
    includelib cvhaartraining.lib
   includelib cxts.lib
   includelib cvaux.lib
   includelib ml.lib
   
CV_HAAR_DO_CANNY_PRUNING equ 1
CV_HAAR_SCALE_IMAGE        equ 2
CV_HAAR_FIND_BIGGEST_OBJECT equ 4 
CV_HAAR_DO_ROUGH_SEARCH     equ 8

  CV_BGR2BGRA  equ  0
  CV_RGB2RGBA  equ  CV_BGR2BGRA

  CV_BGRA2BGR   equ 1
  CV_RGBA2RGB   equ CV_BGRA2BGR

  CV_BGR2RGBA   equ 2
  CV_RGB2BGRA   equ CV_BGR2RGBA

  CV_RGBA2BGR   equ 3
  CV_BGRA2RGB   equ CV_RGBA2BGR

  CV_BGR2RGB    equ 4
  CV_RGB2BGR    equ CV_BGR2RGB

  CV_BGRA2RGBA  equ 5
  CV_RGBA2BGRA  equ CV_BGRA2RGBA

  CV_BGR2GRAY   equ 6
  CV_RGB2GRAY   equ 7
  CV_GRAY2BGR   equ 8
  CV_GRAY2RGB   equ CV_GRAY2BGR
  CV_GRAY2BGRA  equ 9
  CV_GRAY2RGBA  equ CV_GRAY2BGRA
  CV_BGRA2GRAY  equ 10
  CV_RGBA2GRAY  equ 11

  CV_BGR2BGR565 equ 12
  CV_RGB2BGR565 equ 13
  CV_BGR5652BGR equ 14
  CV_BGR5652RGB equ 15
  CV_BGRA2BGR565 equ 16
  CV_RGBA2BGR565 equ 17
  CV_BGR5652BGRA equ 18
  CV_BGR5652RGBA equ 19

  CV_GRAY2BGR565 equ 20
  CV_BGR5652GRAY equ 21

  CV_BGR2BGR555  equ 22
  CV_RGB2BGR555  equ 23
  CV_BGR5552BGR  equ 24
  CV_BGR5552RGB  equ 25
  CV_BGRA2BGR555 equ 26
  CV_RGBA2BGR555 equ 27
  CV_BGR5552BGRA equ 28
  CV_BGR5552RGBA equ 29

  CV_GRAY2BGR555 equ 30
  CV_BGR5552GRAY equ 31

  CV_BGR2equYZ     equ 32
  CV_RGB2XYZ     equ 33
  CV_XYZ2BGR     equ 34
  CV_XYZ2RGB     equ 35

  CV_BGR2YCrCb   equ 36
  CV_RGB2YCrCb   equ 37
  CV_YCrCb2BGR   equ 38
  CV_YCrCb2RGB   equ 39

  CV_BGR2HSV     equ 40
  CV_RGB2HSV     equ 41

  CV_BGR2Lab     equ 44
  CV_RGB2Lab     equ 45

  CV_BayerBG2BGR equ 46
  CV_BayerGB2BGR equ 47
  CV_BayerRG2BGR equ 48
  CV_BayerGR2BGR equ 49

  CV_BayerBG2RGB equ CV_BayerRG2BGR
  CV_BayerGB2RGB equ CV_BayerGR2BGR
  CV_BayerRG2RGB equ CV_BayerBG2BGR
  CV_BayerGR2RGB equ CV_BayerGB2BGR

  CV_BGR2Luv     equ 50
  CV_RGB2Luv     equ 51
  CV_BGR2HLS     equ 52
  CV_RGB2HLS     equ 53

  CV_HSV2BGR     equ 54
  CV_HSV2RGB     equ 55

  CV_Lab2BGR     equ 56
  CV_Lab2RGB     equ 57
  CV_Luv2BGR     equ 58
  CV_Luv2RGB     equ 59
  CV_HLS2BGR     equ 60
  CV_HLS2RGB      equ 61

  CV_COLORCVT_MAX equ 100
  
	CV_TERMCRIT_ITER   equ 1
	CV_TERMCRIT_NUMBER equ CV_TERMCRIT_ITER
	CV_TERMCRIT_EPS    equ 2
  
	CV_HIST_ARRAY    equ     0
	CV_HIST_SPARSE   equ     1
	CV_HIST_TREE     equ     CV_HIST_SPARSE

ifndef MIN
MIN macro a,b
	exitm <( ( a ) > ( b ) ? ( b ) : ( a ) ) >
	endm
endif 
ifndef MAX
MAX macro a,b
	exitm <( ( a ) < ( b ) ? ( b ) : ( a ) ) >
	endm
endif 

IplImage struct
		nSize			dword 0;      
		ID				dword 0;            
		nChannels		dword 0;     
		alphaChannel	dword 0;  
		depth			dword 0	;
		colorModel		byte 4 dup(?); 
		channelSeq		byte 4 dup(?); 
		dataOrder		dword 0; 
		origin			dword 0;  
		_align			dword 0; 
		_width			dword 0; 
		height			dword 0; 
		roi				dword 0;
		maskROI			dword 0;
		imageId			dword 0;
		tileInfo		dword 0;
		imageSize		dword 0;
		imageData		dword 0;
		widthStep		dword 0;
		BorderMode		dword 4 dup (?);
		BorderConst		dword 4 dup (?)
		imageDataOrigin	dword 0 ; 
IplImage ends

cvTermCriteria struct
	_type 		dword 0
	max_iter 	dword 0
	epsilon 	qword 0
cvTermCriteria ends

fCopyIplImageToDC proto :dword,:dword

; This structure is equivalent of cvScalar
scalar struct
v1 qword 0
v2 qword 0
v3 qword 0
v4 qword 0
scalar ends

CvConnectedComp struct
	area qword 0
	value scalar <0>
	rect RECT <0>
	contour dword 0
CvConnectedComp ends


CvPoint2D32f struct
	x dword 0
	y dword 0
CvPoint2D32f ends

CvSize2D32f struct
	_width dword 0
	height dword 0
CvSize2D32f ends

CvBox2D struct
	center CvPoint2D32f <0>
	_size CvSize2D32f <0>
	angle dword 0
CvBox2D ends



;CvMatND struct
;	_type dword 0
;	dims dword 0
;	refcount dword 0
;	hdr_refcount dword 0	
;CvMatND ends

CvMatND	struct 
	type_			DWORD	?
	dims			DWORD	?
	refcount		DWORD	?
	hdr_refcount	DWORD	?
	union data
	_ptr		DWORD	?
	fl			DWORD	?
	_db			DWORD	?
	i			DWORD	?
	s			DWORD	?
	ends
	struct dim
	size_	DWORD	?
	step	DWORD	?
	ends
CvMatND	ends

CvHistogram struct
	_type dword 0
	bins dword 0
	thresh dword 0
	thresh2 dword 0
	mat CvMatND <?>
CvHistogram ends

CvScalar	struct 
	val	REAL8 4 dup (?)
CvScalar	ends

.data
sc qword 1.2
sc_3 qword 3.0
sc_8 qword 8.0
sc_clr qword 225.0,225.0,225.0,225.0
cascade dword 0
storage dword 0
k qword 0.04

tr qword 20
tr2 qword 100

hdims dword 16

vmin dword 10
vmax dword 256
smin dword 60
tmpsc scalar <?>
tmpsc2 scalar <?>

track_object dword -1

.data?
	pres POINT <?>
	dim_arr dword 16 dup (0,180)
.code

MIN2 proc a:dword,b:dword
	
	mov eax,a
	mov edx,b
	cmp edx,eax
	jg ret_b
	xchg eax,edx
	ret_b:
	ret
MIN2 endp

MAX2 proc a:dword,b:dword
	mov eax,a
	mov edx,b
	cmp edx,eax
	jl @f
	xchg eax,edx
	@@:
	ret
MAX2 endp

FaceDetect proc uses esi edi lpFileName:dword, lpRect:Dword
	LOCAL buff[256]:dword
	LOCAL buff2[256]:dword
	LOCAL RegH:dword
	LOCAL tmp,smallimg,gray:dword 
	LOCAL face:dword
	LOCAL img,rct,err_code:dword
	LOCAL r:RECT
	LOCAL s:scalar
	LOCAL p:POINT
	LOCAL fcount:dword
	

; Set Up everything
		mov fcount,0
		
		invoke GetAppPath,addr buff
		invoke SetCurrentDirectory,addr buff
		
		cmp cascade,0
		jnz @f
		invoke cvLoad,CADD("Data\haarcascades\haarcascade_frontalface_alt2.xml"),0,0,0
		.if eax==0
			invoke MessageBox,0,CADD("Cannot load cascade"),0,MB_OK
			invoke PostQuitMessage,0
		.endif
		mov cascade,eax
		invoke cvCreateMemStorage,0
		mov storage,eax
		@@:
		
		
		; Img Structure
		; +40 := width
		; +44 := height
		invoke cvLoadImage,lpFileName,1
		.if eax!=0
				mov img,eax
				
				push [eax+40]
				pop p.x
				push [eax+44]
				pop p.y
				invoke cvCreateImage,p,8,1
				mov gray,eax
				
				invoke cvCreateImage,p,8,1
				mov smallimg,eax
				
				invoke cvCvtColor,img,gray,6 ;CV_BGR2GRAY
				invoke cvResize,gray,smallimg,1
				invoke cvEqualizeHist,smallimg,smallimg
				invoke cvClearMemStorage,storage
				
				mov eax,img
				push [eax+40]
				pop pres.x
				push [eax+44]
				pop pres.y
				
				shr pres.x,3
				shr pres.y,3
				
			;	push 40
			;	pop pres.x
			;	push 40
			;	pop pres.y
				
			;	invoke dw2a,[esi+40],addr buff
			;	invoke SetWindowText,hwnd,addr buff
				
				
				
				invoke cvHaarDetectObjects,smallimg,cascade,storage,sc,2,CV_HAAR_DO_CANNY_PRUNING, pres
				mov face,eax
				
				; invoke GetTickCount
				; xchg eax,edx
				; pop ecx
				; sub edx,ecx
				; invoke dw2a,edx,addr buff
				; invoke MessageBox,hwnd,addr buff,0,MB_OK
				; mov esi,face
				; invoke dw2a,[esi+68],addr buff
				; invoke MessageBox,hWnd,addr buff,0,MB_OK
				
				xor ecx,ecx
				@@:
				push ecx
				invoke cvGetSeqElem,face,ecx
				.if eax!=0
					mov rct,eax
					mov esi,eax
					assume esi:ptr RECT
					
					mov eax,lpRect
					add eax,4
					
					mov ecx,fcount
					shl ecx,4
					
					push [esi].left
					pop [eax+ecx]
					
					push [esi].top
					pop [eax+ecx+4]
					
					push [esi].right
					mov edx,[esi].left
					add [esp],edx
					pop[eax+ecx+8]
					
					push [esi].bottom
					mov edx,[esi].top
					add [esp],edx
					pop [eax+ecx+12]
					
					inc fcount
					assume esi:nothing
					mov err_code,1
				.else
				;	invoke MessageBox,0,CADD("Cannot detect anything"),0,MB_OK
					mov err_code,-1
				.endif
				pop ecx
				inc ecx
				mov esi,face
				cmp ecx,[esi+68] ; +68 a value of how much face detected
				jl @b
		.endif
		
		mov eax,lpRect
		mov esi,face
		push [esi+68]
		pop [eax]
		
		invoke cvReleaseImage,addr gray
		invoke cvReleaseImage,addr smallimg
		invoke cvReleaseImage,addr img
		
		end_p:
		mov eax,err_code

ret
FaceDetect endp

ObjectTrack2 proc uses esi edi cvArrImage:dword,DC:dword,lpRect:dword
	LOCAL img,hsv,hue,_mask,backproject,hist,histimg:dword
	LOCAL p:POINT
	LOCAL r:RECT
	LOCAL ctc:cvTermCriteria
	LOCAL track_comp:CvConnectedComp
	LOCAL data:CvBox2D
	LOCAL buff[256]:dword
	LOCAL tmp:qword
	LOCAL tmp2:dword
	LOCAL max_value,_vmin:dword
	
	mov edx,lpRect
	mov eax,[edx]
	.if eax<=0
		ret
	.endif
	mov eax,[edx+4]
	.if eax<=0
		ret
	.endif
	
	mov esi,cvArrImage	
	push [esi].IplImage._width
	pop p.x
	push [esi].IplImage.height
	pop p.y
	invoke cvCreateImage,p,8,3
	mov img,eax
	
	mov edi,img
	push [esi].IplImage.origin
	pop [edi].IplImage.origin
	
	
	invoke cvCreateImage,p,8,3
	mov hsv,eax
	
	invoke cvCreateImage,p,8,1
	mov hue,eax
	
	invoke cvCreateImage,p,8,1
	mov _mask,eax
	
	invoke cvCreateImage,p,8,1
	mov backproject,eax
	
	push 320
	pop p.x
	push 200
	pop p.y
	
	invoke cvCreateImage,p,8,3
	mov histimg,eax
	
	invoke cvSetZero,histimg
	
	lea eax,dim_arr
	mov tmp2,eax
	invoke cvCreateHist,1,addr hdims,CV_HIST_ARRAY,addr tmp2,1
	mov hist,eax
	
	invoke cvCvtColor,esi,hsv,CV_RGB2HSV
	
	push 0
	fild dword ptr [esp]
	fstp tmpsc.v1
	pop eax
	fild smin
	fstp tmpsc.v2
	invoke MIN2,vmin,vmax
	push eax
	fild dword ptr[esp]
	pop eax
	fstp tmpsc.v3
	push 0
	fild dword ptr[esp]
	fstp tmpsc.v4
	pop eax
	
	push 180
	fild dword ptr[esp]
	fstp tmpsc2.v1
	pop eax
	push 256
	fild dword ptr[esp]
	fstp tmpsc2.v2
	pop eax
	invoke MAX2,vmin,vmax
	push eax
	fild dword ptr[esp]
	fstp tmpsc2.v3
	pop eax
	push 0
	fild dword ptr[esp]
	fstp tmpsc2.v4
	pop eax
	
	
	invoke cvInRangeS,hsv,tmpsc,tmpsc2,_mask
	invoke cvSplit,hsv,hue,0,0,0
	
	mov edx,lpRect
	push [edx]
	pop r.left
	push [edx+4]
	pop r.top
	push [edx+8]
	pop r.right
	push [edx+12]
	pop r.bottom
	
	fld CDBL(0.0)
	fstp max_value
		
	invoke cvSetImageROI,hue,r
	invoke cvSetImageROI,_mask,r
		invoke cvCalcArrHist,addr hue,hist,0,_mask
		invoke cvGetMinMaxHistValue,hist,0,addr max_value,0,0
		mov edx,hist
		invoke cvConvertScale,[edx].CvHistogram.bins,[edx].CvHistogram.bins,1,0
	invoke cvResetImageROI,hue
	invoke cvResetImageROI,_mask
	
	invoke cvCalcArrBackProject,addr hue,backproject,hist
	
	push CV_TERMCRIT_EPS or CV_TERMCRIT_ITER
	pop ctc._type
	push 10
	pop ctc.max_iter
	fld CDBL(1.0)
	fstp ctc.epsilon
	invoke cvAnd,backproject,_mask,backproject,0
	invoke cvCamShift,backproject,r,ctc,addr track_comp,addr data
	
	invoke cvCvtColor,backproject,hsv,CV_GRAY2RGB
	invoke fCopyIplImageToDC,hsv,DC
	
	mov edx,hist
	mov edx,[edx].CvHistogram.bins
	mov edx,[edx]
	
	.if edx==0
		invoke TextOut,DC,0,200,CADD("Error"),5
	.else
		invoke TextOut,DC,0,200,CADD("Oke"),3
	.endif
	
	
	fld max_value
	fstp tmp
	invoke FloatToStr,tmp,addr buff
	invoke TextOut,DC,0,50,addr buff,6
	
	fld data.center.y
	fstp tmp
	invoke FloatToStr,tmp,addr buff
	invoke TextOut,DC,0,80,addr buff,6
	
	
	invoke cvReleaseHist,addr hist
	invoke cvReleaseImage,addr hsv
	invoke cvReleaseImage,addr hue
	invoke cvReleaseImage,addr _mask
	invoke cvReleaseImage,addr backproject
	invoke cvReleaseImage,addr histimg
	
	
	ret
ObjectTrack2 endp

ObjectTrack proc uses esi edi cvArrImage:dword,DC:dword
	LOCAL img,img2,img3,img4:dword
	LOCAL p:POINT
	
	mov esi,cvArrImage
	push [esi].IplImage._width
	pop p.x
	push [esi].IplImage.height
	pop p.y
	
	invoke cvCreateImage,p,8,1
	mov img,eax
	invoke cvCreateImage,p,8,1
	mov img2,eax
	invoke cvCreateImage,p,8,3
	mov img3,eax
	invoke cvCreateImage,p,32,1
	mov img4,eax
	
	invoke cvCvtColor,cvArrImage,img2,CV_RGB2GRAY
	invoke cvCornerHarris,img2,img4,3,7, k
	invoke cvCanny,img2,img,tr,tr2,3
	
	invoke cvCvtColor,img,img3,CV_GRAY2RGB
	invoke fCopyIplImageToDC,img3,DC
	
	
	invoke cvReleaseImage,addr img4
	invoke cvReleaseImage,addr img3
	invoke cvReleaseImage,addr img2
	invoke cvReleaseImage,addr img
	
	ret
ObjectTrack endp

fCopyIplImageToDC proc uses esi edi cvArrIplImage:dword,DC:dword
	LOCAL l:fLayer
	LOCAL b:BITMAP
	LOCAL p:POINT
	LOCAL img:dword
	
	mov esi,cvArrIplImage
	assume esi:ptr IplImage
		invoke fNewLayer,addr l,[esi]._width,[esi].height
		mov edi,[esi].imageData
		invoke GetObject,l.bmp,sizeof BITMAP,addr b
		invoke cvFlip,esi,0,0
		
		push [esi]._width
		pop p.x
		push [esi].height
		pop p.y
		
		invoke cvCreateImage,p,8,4
		mov img,eax
		
		invoke cvCvtColor,esi,img,CV_RGB2RGBA
		
		mov edx,img
		invoke MemCopy,[edx].IplImage.imageData,b.bmBits,[edx].IplImage.imageSize
		invoke BitBlt,DC,0,0,[esi]._width,[esi].height,l.DC,0,0,SRCCOPY
		invoke cvFlip,esi,0,0
		invoke fDeleteLayer,addr l
		
		invoke cvReleaseImage,addr img
		
	;	mov edx,img
		mov eax,[esi].depth
	assume esi:nothing
	
	ret
fCopyIplImageToDC endp